MODULE DebugCode;

FROM StreamFile IMPORT ChanId, Open, read, Close, OpenResults;
FROM TextIO IMPORT ReadString, WriteLn, WriteString, WriteChar, SkipLine;
FROM IOResult IMPORT ReadResult, ReadResults;
FROM StdChans IMPORT StdInChan, StdOutChan;
FROM WholeIO  IMPORT WriteInt, WriteCard;

TYPE line = ARRAY[0..120] OF CHAR;
     AllLines = ARRAY [1..1000] OF line;

     word = ARRAY[0..20] OF CHAR;
     WordFreq = RECORD
                freq   : INTEGER;
                aword   : word;
            END;
     AllWords = ARRAY [1..1000] OF WordFreq;

VAR
  infile, stdOut, stdIn : ChanId;
  res : OpenResults;
  inputline: line;
  i, j, k : INTEGER;
  charval : INTEGER;
  numlines: INTEGER;
  wordindex: INTEGER;
  numwords: INTEGER;
  document: AllLines;
  wordsindoc: AllWords;

BEGIN
  stdOut := StdOutChan(); (* to force screen output *)
  stdIn := StdInChan(); (* to force keyboard input *)

  (* The first part of the code reads all lines from the file *)
  (* into inputline and stores them in the document array *)
  Open (infile, "input.txt", read, res);
  IF res = opened
    THEN
      i := 1;
      REPEAT  (* Collect the numbers from the file *)
        ReadString (infile, inputline);
        (* WriteString (stdOut, inputline); *)
        IF ReadResult (infile) = allRight
          THEN
            SkipLine (infile);
            (* NOW PROCESS THE LINE TO FIND WORDS *)
            document[i]:=inputline;
            (* WriteLn (stdOut); *)
            i:=i+1;
          END;  (* if *)
      UNTIL ReadResult (infile) # allRight;
     Close (infile);
     WriteLn (stdOut);
    ELSE
     WriteString (stdOut,"Sorry, couldn't open the file");
     WriteLn (stdOut);
    END; (* if *)
    numlines :=i-1; (* i gets incremented for EOF line*)
    
    (* The code part of the code cycles through document array *)
    (* in order to identify words in each line*)
    numwords:=0; 
    wordindex := 1;
    FOR i:=1 TO numlines DO 
      j:=0; k:=0; 
      WHILE ORD(document[i][j]) <> 0
      DO
       charval := ORD(document[i][j]);
       IF ((charval >= 48) AND (charval < 58)) OR
          ((charval >= 65) AND (charval < 91)) OR
          ((charval >= 97) AND (charval < 123)) OR
          ((charval = 45)) OR ((charval=39))
         THEN (* is it a number or upper/lower case char *)
           wordsindoc[wordindex].aword[k] := document[i][j];
           WriteChar(stdOut, wordsindoc[wordindex].aword[k]);
           WriteCard(stdOut, charval, 4);
           k:=k+1;
         ELSE (* end of word *)
           WriteLn (stdOut);
           WriteString(stdOut, "Does this happen more than once for EOL-->");
           wordindex:=wordindex+1;
           numwords:=numwords+1;
           k:=0;
         END;
       j:=j+1;
      END;
    END;
    numwords:=numwords-1;
    WriteInt(stdOut, numwords, 3); 
    WriteLn(stdOut);
END DebugCode.