MODULE RecordwithProc;

FROM StreamFile IMPORT ChanId, Open, read, Close, OpenResults;
FROM TextIO IMPORT ReadString, WriteLn, WriteString, WriteChar, SkipLine;
FROM IOResult IMPORT ReadResult, ReadResults;
FROM StdChans IMPORT StdInChan, StdOutChan;
FROM WholeIO  IMPORT WriteInt;

TYPE line = ARRAY[0..100] OF CHAR;
     Word = RECORD
                 freq   : INTEGER;
                 word   : line;
            END;
     AllWords = ARRAY [1..1000] OF Word; 
     
VAR
  infile, stdOut, stdIn : ChanId;
  res : OpenResults;
  inputline: line;
  i, j, k   : INTEGER;
  numlines  : INTEGER;
  wordsfound: AllWords;
  
  PROCEDURE ReadLines(VAR wdfd:AllWords; VAR nolines: INTEGER);
  (* Read and Store from input into document *)
  BEGIN
  stdOut := StdOutChan(); (* to force screen output *)
  stdIn := StdInChan(); (* to force keyboard input *)
  
  Open (infile, "input.txt", read, res);
  IF res = opened
    THEN
      i := 1;
      REPEAT  (* Collect the numbers from the file *)
        ReadString (infile, wordsfound[i].word); 
        IF ReadResult (infile) = allRight
          THEN
            SkipLine (infile);
            wdfd[i].word:=wdfd[i].word;
            WriteString (stdOut, wdfd[i].word);
            WriteString (stdOut, wdfd[i].word);
            WriteLn (stdOut);
            i:=i+1;
          END;  (* if *)
      UNTIL ReadResult (infile) # allRight;
     Close (infile);
     WriteLn (stdOut);
    ELSE
     WriteString (stdOut,"Sorry, couldn't open the file");
     WriteLn (stdOut);
    END; (* if *)
END ReadLines;

BEGIN

    (* CALL PROCEDURE *)
    
    ReadLines(wordsfound, numlines);

    (* output wordsfound record by record, line by line, char by char *)
    numlines :=i-1;
    WriteInt(stdOut, numlines, 3);
    WriteLn (stdOut);
    
    FOR i:= 1 TO numlines DO
      j:=0;
      REPEAT 
      IF ORD(wordsfound[i].word[j]) <> 0 
        THEN  
          WriteChar (stdOut, wordsfound[i].word[j]); 
          j :=j+1;
      END;
      UNTIL ORD(wordsfound[i].word[j]) = 0 ;
      WriteLn (stdOut);
    END;
END RecordwithProc.